<?php

//////////////////////////
// Enumerated Constants //
//////////////////////////

// Site Authentication Level (softwaresite) - SAL_<level name>
$f3->set('SAL_default', 0);
$f3->set('SAL_company_admin', 1);

// Promotion Types (promotion) - PT_<type name>
$f3->set('PT_base_only', 'B');
$f3->set('PT_bonus_only', 'O');
$f3->set('PT_base_plus_bonus', 'U');

// Customer Invoice Term (promotion) - CIT_<term>
$f3->set('CIT_Debit','D');         // Charge the customer
$f3->set('CIT_Credit','C');        // Credit the customer
$f3->set('CIT_DoNotInvoice','X');  // Do not invoice the customer

//////////////////////////
// Application Globals  //
//////////////////////////
$f3->set('TZ','America/New_York');


// Verbosity level of the stack trace. Assign values between 0 to 3 for increasing verbosity levels as follow:
//     0 : suppresses logs of the stack trace.
//     1 : logs files & lines.
//     2 : logs classes & functions as well.
//     3 : logs detailed infos of the objects as well.
// NOTICE: Only the default value of  0 should be used on production servers.
$f3->set('DEBUG',$f3->get('DEBUG_LEVEL')); 

// Name of app folder.
// Now set in index.php
// $f3->set('APP_FOLDER', 'i5s6Wc9VBf7yV');

// Search path for user interface files used by
// the View and Template classes' render() method.
// Accepts a pipe (|), comma (,), or semi-colon (;) as separator for multiple paths.
$f3->set('UI', $f3->get('APP_FOLDER') . '/view/');

// Autoload for app classes.
$f3->set('AUTOLOAD', $f3->get('APP_FOLDER') . '/controller/;' . $f3->get('APP_FOLDER') . '/class/;' . '../../f3_lib_9Xr6975GUj/class/');

// Temporary folder for cache,
// filesystem locks, compiled F3 templates, etc.
$f3->set('TEMP', $f3->get('APP_FOLDER') . '/cache/');

// Location of custom logs.
$f3->set('LOGS', $f3->get('APP_FOLDER') . '/logs/');

// Location of rotating Monologs.
$f3->set('MONOLOG', $f3->get('APP_FOLDER') . '/logs/openffp.log');

// Front page of OpenFFP.  Used to redirect to a home base.
$f3->set('OPENFFP_BASE','http://openffp.com');

// List of field names that should never be populated from any request payload.
// They are removed from each DB->scheme before usage.
$f3->set('DB_NOCOPY',[
	'id','create_date','update_date','company_id', 'softwarevendor_id',
	'companysoftware_id','rewardvendor_id','tran_stat_id','tran_stat_desc'
]);

// Hash Algorithm to use for hash function.
$f3->set('HASH_ALGO','sha256');

// OpenFFP Dashboard
$f3->set('DASHBOARD_BASE','http://openffp.com/dash');
// Marketing site production url.
$f3->set('SITE_BASE','http://uk.openffp.com');
// Support site - Reamaze.com (Netherlands)
$f3->set('SUPPORT_BASE','http://openffp.com/support');


///////////
// MySQL //
///////////
$f3->set('DB_SQLDATE','Y-m-d H:i:s');

// Used in the urls to obscure and to fetch data from select database.
// Used in dataset routes to feed the dashboard.
$f3->set('DBKEYS', ['PRr98Q47' => 'DB', 'DE77625Q' => 'DB_DEV', 'SA85684j' => 'DB_TRIAL']);

// Database connections //
$f3->set('DB_CONNECT','mysql:host=localhost;port=3306;dbname=openffp_api');
$f3->set('DB_USER','openffp_apiuser');
$f3->set('DB_PWD','X9suMFDlD0wnl2g');

$f3->set('DB_CONNECT_TRIAL','mysql:host=localhost;port=3306;dbname=openffp_api_sand');
$f3->set('DB_USER_TRIAL','openffp_apiusand');
$f3->set('DB_PWD_TRIAL','Q3hUm5EcpFaqUT592yP');


// Change vars to develope as applicable.
if ( $f3->get('CODE_MODE') == 'DEV' )
{
	// Database connection.  Change dbname only.
	$f3->set('DB_CONNECT','mysql:host=localhost;port=3306;dbname=openffp_api_dev');
	$f3->set('DB_USER','openffp_apiudev');
	$f3->set('DB_PWD','q35r6k2ddesKtd9');
	$f3->set('DB_SQLDATE','Y-m-d H:i:s');

}

/////////////////////////
// Contact Information //
/////////////////////////
$f3->set('twitterlink','https://twitter.com/openffp');

////////////////////////
// Cyfe.com Dashboard //
////////////////////////
$f3->set('DASHBOARD_KEY','M3keQrZTBR2aVwRGuTFwWy2cY6fe6WXKCAAks353ymM7R5QgASjz5w4BntPq8K9X');


/////////////////////////////////
// CryptoGuard Security Phrase //
/////////////////////////////////
$f3->set('SECRET','7R3dBhkgSkjZ5d5WJdB9pdcgHTSgSu8t');


//////////////////////
// SendGrid Options //
//////////////////////
$f3->set('sg_username','dcuinc');
$f3->set('sg_password','2846#G*YMbD7r2m');
// Location of where images are stored that are used for email.
$f3->set('sg_images', $f3->get('PANEL_BASE') . '/global/img/');
$f3->set('sg_copyaddr','support@openffp.com');

/////////////////
// Apiary Info //
/////////////////
// This needs put into a call to the OpenFFP API.
// This setting is made part of the link to show
// the Apiary documentation.
// I need a link to the latest version of the API documentation.
// Probably a free-route call to the OpenFFP API?
$f3->set('api_curr_version','v1');
$f3->set('curr_apiary_link', 'http://docs.openffp' . $f3->get('api_curr_version') . '.apiary.io/');

$f3->set('trial_api','https://trialapi.openffp.com/' . $f3->get('api_curr_version'));


////////////////////////////
// OpenFFP Support Center //
////////////////////////////
$f3->set('support_center_link','http://support.openffp.com');
$f3->set('getting_started_link','http://o.openffp.com/gettingstarted');
$f3->set('start_production_link','???');
$f3->set('support_email_addr','support@openffp.com');
$f3->set('support_center_name','Support');
$f3->set('support_form_url', $f3->get('PANEL_BASE') . '/support/form');
$f3->set('support_phone','+1 904.328.3468');


///////////////////////////
// Dashboard Settings    //
///////////////////////////
$f3->set('dashboard_name', "OpenFFP Dashboard");
$f3->set('dashboard_url', $f3->get('PANEL_BASE') . '/account/login');

///////////////////////////
// OpenFFP URL Shortener //
///////////////////////////


/////////////////
// Mono Logger //
/////////////////
$f3->set('logger_name','OpenFFP_DevPanel');


/////////////////////
// Pushover Alerts //
/////////////////////
$f3->set('pushover_user_key','uUMK7Fbe2FmBGRX6JbTTYAwsvoyStB');
$f3->set('pushover_api_key','auAVjNGLEiedfBtAzdCn2zV98mzmCR');

///////////////
// Currency  //
///////////////
$f3->set('OER_end_point','http://openexchangerates.org/api/');
$f3->set('OER_app_id','7b69adc358ec4b85a7e6d46a9979b4c6');


