<?php

// Reroute root of application with no parameters to root
// domain of openffp.com
$f3->route('GET /', 'LoginController->processLoginForm');
$f3->route('GET /helloworld', 'LoginController->helloworld');

////////////////////////////////////////////
// Login / Registration / Forgot Password //
////////////////////////////////////////////
// OpenFFP Dashboard - TBA
// $f3->route('GET|POST @login: /account/login', 'LoginController->processLoginForm');
//
// Cyfe Dashboard Whitelabel
$f3->route('GET @login: /account/login', 'LoginController->processLoginForm');
$f3->route('GET|POST @register: /account/register', 'LoginController->processRegistrationForm');
$f3->route('GET @confirm: /account/confirm/@userhash', 'LoginController->processConfirmation');
//$f3->route('GET @profile: /account/profile/@userhash', 'LoginController->processConfirmation');

// $f3->route('GET|POST @forgotpassword: /account/forgotpassword', 'LoginController->processForgottenPassword');

$f3->redirect('GET @contactus: /contactus', $f3->get('OPENFFP_BASE') . '/contactus');
$f3->redirect('GET @faq: /faq', $f3->get('OPENFFP_BASE') . '/frequent-asked-questions');
$f3->redirect('GET @home: /home', $f3->get('OPENFFP_BASE'));


//////////////////
// Support Form //
//////////////////
$f3->route('GET|POST @support: /support/form', 'SupportController->processSupportForm');
$f3->route('GET @supportcenter: /support/center', 'SupportController->showSupportCenter');


///////////////
// Site Maps //
///////////////
$f3->route('GET @gensitemap: /sitemap/generate', 'SitemapController->generateSiteMap');

///////////////
// Currency  //
///////////////

// This will be run once per day via cron on openffp.com to load the previous day
// EOD rates and call them the current days rates.  Logged to file and logentries.com
$f3->route('GET /currency/update/exchangerates', 'CurrencyController->getLatestRates');


////////////////////////////////////////////
// Invoicing and Payments                 //
////////////////////////////////////////////

// Pingback from PaymentWall Payment Processing.
$f3->route('GET /payments/.........', 'CurrencyController->getLatestRates');

// Testing 2checkout hosted payment form.



////////////////
// Dashboards //
////////////////
// These are routes that fuel the Cyfe dashboard.
// Cyfe is a better value than developing it all myself.
// $14 for unlimited dashboards?  Shareable URL's with optional password?
// All i have to do is feed it data?  And it does all the front end work?  Yes!

// Encrypt parts of urls to hide them.
$f3->route('GET /datasets/encode/@item', 'DatasetController->encodeItem');

/////////////////////////////////////////////////////
// Software CUSTOMER Dashboard by Cyfe             //
/////////////////////////////////////////////////////
// Get dataset of site activity for Cyfe dashboard //
// @custid is an encrypted value of the cust id.
$f3->route('GET /datasets/dashboard_siteactivity/numrewards/PRr98Q47/@custid', 'DatasetController->dashSiteActivity');
$f3->route('GET /datasets/dashboard_siteactivity/numrewards/SA85684j/@custid', 'DatasetController->dashSiteActivity');
$f3->route('GET /datasets/dashboard_siteactivity/apicalls/PRr98Q47/@custid', 'DatasetController->dashSiteActivity');
$f3->route('GET /datasets/dashboard_siteactivity/apicalls/SA85684j/@custid', 'DatasetController->dashSiteActivity');
$f3->route('GET /datasets/dashboard_siteactivity/rewardamt/PRr98Q47/@custid', 'DatasetController->dashSiteActivity');
$f3->route('GET /datasets/dashboard_siteactivity/rewardamt/SA85684j/@custid', 'DatasetController->dashSiteActivity');
$f3->route('GET /datasets/dashboard_siteactivity/revenueamt/PRr98Q47/@custid', 'DatasetController->dashSiteActivity');
$f3->route('GET /datasets/dashboard_siteactivity/revenueamt/SA85684j/@custid', 'DatasetController->dashSiteActivity');

///////////////////////////////////////
// Software VENDOR Dashboard by Cyfe //
///////////////////////////////////////

// Get dataset of active sites for Cyfe dashboard with keys for vendor to use.
$f3->route('GET /datasets/dashboard_softvendor/activesitekeys/PRr98Q47/@svendid', 'DatasetController->dashSoftwareVendor');
$f3->route('GET /datasets/dashboard_softvendor/activesitekeys/SA85684j/@svendid', 'DatasetController->dashSoftwareVendor');
$f3->route('GET /datasets/dashboard_softvendor/adminsites/PRr98Q47/@svendid', 'DatasetController->dashSoftwareVendor');
$f3->route('GET /datasets/dashboard_softvendor/adminsites/SA85684j/@svendid', 'DatasetController->dashSoftwareVendor');

// Play with geoip sometime.
// $f3->route('GET /datasets/dashboard_geoip/', 'DatasetController->dashSiteActivity');

/////////////////////////////////////////////
// OpenFFP Software Vendor Dashboard - TBD //
/////////////////////////////////////////////
// $f3->route('GET /dashboard', 'PanelController->showDashBoard');





// // Testing
// $f3->route('GET /boom', 'TestController->testBoomeranger');
// $f3->route('GET /emailtest', 'TestController->sendgridtest');
// $f3->route('GET /showemail', 'TestController->showemail');
// $f3->route('GET /showdate', 'TestController->showdate');



// ///////

// $f3->route('GET /password', 'LoginController->showPasswordForm');
// $f3->route('POST /password', 'LoginController->processPasswordForm');

// $f3->route('GET /confirmpass', 'LoginController->confirmPassword');
// $f3->route('POST /confirmpass', 'LoginController->confirmPassword');


// // Test
// $f3->route('GET /api/award/testbuda', 'AwardController->testbuda');

