<?php

//////////////////////////
// Enumerated Constants //
//////////////////////////

// Site Authentication Level (softwaresite) - SAL_<level name>

// Promotion Types (promotion) - PT_<type name>

// Customer Invoice Term (promotion) - CIT_<term>

//////////////////////////
// Application Globals  //
//////////////////////////
$f3->set('TZ','America/New_York');


// Verbosity level of the stack trace. Assign values between 0 to 3 for increasing verbosity levels as follow:
//     0 : suppresses logs of the stack trace.
//     1 : logs files & lines.
//     2 : logs classes & functions as well.
//     3 : logs detailed infos of the objects as well.
// NOTICE: Only the default value of  0 should be used on production servers.
$f3->set('DEBUG',$f3->get('DEBUG_LEVEL')); 

// Name of app folder.
// Now set in index.php
// $f3->set('APP_FOLDER', 'i5s6Wc9VBf7yV');

// Search path for user interface files used by
// the View and Template classes' render() method.
// Accepts a pipe (|), comma (,), or semi-colon (;) as separator for multiple paths.
$f3->set('UI', $f3->get('APP_FOLDER') . '/view/');

// Autoload for app classes.
$f3->set('AUTOLOAD', $f3->get('APP_FOLDER') . '/controller/;' . $f3->get('APP_FOLDER') . '/class/');

// Temporary folder for cache,
// filesystem locks, compiled F3 templates, etc.
$f3->set('TEMP', $f3->get('APP_FOLDER') . '/cache/');

// Location of custom logs.
$f3->set('LOGS', $f3->get('APP_FOLDER') . '/logs/');

// Location of rotating Monologs.
$f3->set('MONOLOG', $f3->get('APP_FOLDER') . '/logs/online-ihamms-com.log');

// Front page of iHAMMS Online Web.
$f3->set('APP_BASE','https://ihamms.com/online');

// Global Asset Base.
$f3->set('GLOBAL_ASSETS',$f3->get('APP_BASE') . '/global/');

// Asset base for chosen theme - Metronic Admin Template.
$f3->set('THEME_ASSETS', $f3->get('GLOBAL_ASSETS') . 'theme/' . $f3->get('COOKIE.chaincode') . '/');

// Hash Algorithm to use for hash function.
$f3->set('HASH_ALGO','sha256');

// Encryption Key
$f3->set('CRYPT_KEY','ec5gCMDk8nyHMxvM5bPXIn6nvf0oebfb');

// Page Timeout Minutes
$f3->set('PAGE_TIMEOUT','30');

// Global system mode settings.
$f3->set('sys_mode_code_demo','DEMONSTRATION');
$f3->set('sys_mode_desc_demo','You are in the DEMO system. Anything you do here ' .
	'will not be official and never sent to the airlines.  No information entered herein can ' .
	'be transferred to the PRODUCTION system.');
$f3->set('sys_mode_code_prod','PRODUCTION');
$f3->set('sys_mode_desc_prod','You are in the live system. All rewards will be ' .
	'recorded and sent to the airline during production processing.');

// Reroute errors before displaying them so that the URL is 
// not mistakingly revealed by the debug functions or default
// page info.
$f3->set('ONERROR',function($f3){
	$f3->reroute('/showerror/' . $f3->get('ERROR.code') . '/' . $f3->get('ERROR.status'));
});

// Various JS components to enable in controllers as needed by various pages.
$f3->set('jsc_bootstrap_multiselect','BSMS');
$f3->set('jsc_bootstrap_daterangepicker','BSDP');

// System name - used in page titles
$f3->set('SYSTEM_NAME','iHAMMS Online');

///////////////////////
// LEGACY IIS SYSTEM //
///////////////////////

// Marker IIS IP Legacy Source Machine
$f3->set('LEGACY_IP','207.30.208.238');

// Legacy login url to use on logout from here.
// New legacy system redirect url setup at https://ihamms.com/{chainname}
$f3->set('LEGACY_LOGIN_URL','https://secure.ihamms.com/');

$f3->set('LEGACY_LOGOUT_URL', $f3->get('APP_BASE') . '/legacylogout');


///////////
// MySQL //
///////////
$f3->set('DB_SQLDATE','Y-m-d H:i:s');

// Used in the urls to obscure and to fetch data from select database.
// Used in dataset routes to feed the dashboard.
$f3->set('DBKEYS', ['PRr98Q47' => 'DB', 'DE77625Q' => 'DB_DEV', 'SA85684j' => 'DB_TRIAL']);

// Database connections //
$f3->set('DB_CONNECT','mysql:host=localhost;port=3306;dbname=openffp_api');
$f3->set('DB_USER','openffp_apiuser');
$f3->set('DB_PWD','X9suMFDlD0wnl2g');

$f3->set('DB_CONNECT_TRIAL','mysql:host=localhost;port=3306;dbname=openffp_api_sand');
$f3->set('DB_USER_TRIAL','openffp_apiusand');
$f3->set('DB_PWD_TRIAL','Q3hUm5EcpFaqUT592yP');


// Change vars to develope as applicable.
if ( $f3->get('CODE_MODE') == 'DEV' )
{
	// Database connection.  Change dbname only.
	$f3->set('DB_CONNECT','mysql:host=localhost;port=3306;dbname=openffp_api_dev');
	$f3->set('DB_USER','openffp_apiudev');
	$f3->set('DB_PWD','q35r6k2ddesKtd9');
	$f3->set('DB_SQLDATE','Y-m-d H:i:s');

}

/////////////////////////
// Contact Information //
/////////////////////////
// $f3->set('twitterlink','https://twitter.com/openffp');

////////////////////////
// Cyfe.com Dashboard //
////////////////////////
// $f3->set('DASHBOARD_KEY','M3keQrZTBR2aVwRGuTFwWy2cY6fe6WXKCAAks353ymM7R5QgASjz5w4BntPq8K9X');


/////////////////////////////////
// CryptoGuard Security Phrase //
/////////////////////////////////
// $f3->set('SECRET','7R3dBhkgSkjZ5d5WJdB9pdcgHTSgSu8t');


//////////////////////
// SendGrid Options //
//////////////////////
// $f3->set('sg_username','dcuinc');
// $f3->set('sg_password','2846#G*YMbD7r2m');
// // Location of where images are stored that are used for email.
// $f3->set('sg_images', $f3->get('PANEL_BASE') . '/global/img/');
// $f3->set('sg_copyaddr','support@openffp.com');

/////////////////
// Apiary Info //
/////////////////
// This needs put into a call to the OpenFFP API.
// This setting is made part of the link to show
// the Apiary documentation.
// I need a link to the latest version of the API documentation.
// Probably a free-route call to the OpenFFP API?
// $f3->set('api_curr_version','v1');
// $f3->set('curr_apiary_link', 'http://docs.openffp' . $f3->get('api_curr_version') . '.apiary.io/');

// $f3->set('trial_api','https://trialapi.openffp.com/' . $f3->get('api_curr_version'));


////////////////
// Mono Logger //
/////////////////
$f3->set('logger_name','OpenFFP_DevPanel');


/////////////////////
// Pushover Alerts //
/////////////////////
$f3->set('pushover_user_key','uUMK7Fbe2FmBGRX6JbTTYAwsvoyStB');
$f3->set('pushover_api_key','auAVjNGLEiedfBtAzdCn2zV98mzmCR');

///////////////
// Currency  //
///////////////
$f3->set('OER_end_point','http://openexchangerates.org/api/');
$f3->set('OER_app_id','7b69adc358ec4b85a7e6d46a9979b4c6');


