    var editor; // Datatables Editor - use a global for the submit and return data rendering 
    $(document).ready(function() {

        editor = new $.fn.dataTable.Editor( {
                // ajax: "https://requestb.in/s7butzs7",
                ajax: "<?php echo $APP_BASE; ?><?php echo \Base::instance()->alias('editadminpropratecodes'); ?>",
                table: "#erctable",
                idSrc:  'ERCId',
                i18n: {
                    error: {
                        system: "A system error has occurred.  Contact technical support!"
                    }
                },
                // formOptions: {
                //     main: {
                //         submit: 'changed'
                //     }
                // },

                fields: [ {
                        label: "Rate Code:",
                        name: "RateCode"
                    }, {
                        label: "Description:",
                        name: "RateDesc"
                    }, {
                        label: "Start Date:",
                        name: "StartDate",
                        type: "datetime"
                    }, {
                        label: "End Date:",
                        name: "EndDate",
                        type: "datetime"
                    }, {
                        name: "PropID",
                        type: "hidden",
                         def: "<?php echo $ratecodeprop; ?>"
                    }, {
                        name: "UpdateDate",
                        type: "hidden"
                    }, {
                        name: "UpdateUser",
                        type: "hidden"
                    }, {
                        name: "CreateDate",
                        type: "hidden"
                    }, {
                        name: "CreateUser",
                        type: "hidden"
                    }, {
                        name: "ERCId",
                        type: "hidden"
                    }, {
                        label: "FFP Eligible?:",
                        name: "EligibilityCode",
                        type:  "radio",
                        def: "0",
                        options: [
                            { label: "Yes", value: 1 },
                            { label: "No",    value: 0 }
                        ]
                    }
                ]
            } );

            // editor.on( 'submitError', function (  e, xhr, err, thrown, data ) {
            //     alert( 'Error' );
            // } );

            // Disable the Rate code field changes on edit.
            editor.on( 'open', function ( e, mode, action ) 
            {
                editor.enable('RateCode');
                if ( action === 'edit' )
                {
                    editor.disable('RateCode');
                }
            } );


        var table = $('#erctable').DataTable({
            // select: "true",
            select: {
                style:    'os'
                // selector: 'td:first-child'
            },
            order: [ 2, 'asc' ],
            "dom": '<"dt-toolbar"><"top"Bf>irt<"bottom"lp><"clear">',

            "columnDefs": [
                { "visible": false, "targets": [1, 2] },
                {
                    // The `data` parameter refers to the data for the cell (defined by the
                    // `data` option, which defaults to the column being worked with, in
                    // this case `data: 0`.
                    "render": function ( data, type, row ) 
                    {
                        if ( data.length > 45 )
                        {
                            return data.substr(0, 45) + '...';
                        }
                        return data;
                    },
                    "targets": [3]
                },


            ],
            // Match the exact column name in the database.
            columns: [
                {
                    data: null,
                    defaultContent: '',
                    className: 'select-checkbox',
                    orderable: false
                },
                { data: "ERCId" },
                { data: "PropID" },
                { data: "RateCode" },
                { data: "RateDesc" },
                { 
                    data: "StartDate",
                    class: "text-center"
                },
                { 
                    data: "EndDate",
                    class: "text-center"
                },
                { 
                    class: "text-center",
                    "data": "EligibilityCode",
                    "render": function (val, type, row) {
                        return val == 0 ? "NO" : "YES";
                    }
                },

                { data: "CreateUser" },
                { 
                    data: "CreateDate",
                    class: "text-center",
                    render: function ( data, type, row ) {
                        return data.substr( 0, 10 );
                    }
                },
                { data: "UpdateUser" },
                { 
                    data: "UpdateDate",
                    class: "text-center",
                    render: function ( data, type, row ) {
                        return data.substr( 0, 10 );
                    }
                }
            ],

            buttons: [

                { extend: "create", editor: editor },
                { extend: "edit",   editor: editor },
                { extend: "remove", editor: editor },

                {
                    extend: 'collection',
                    text: 'Export',
                    buttons: [
                        {
                            extend: 'copy',
                            exportOptions: {
                                columns: ':visible'
                            }
                        },
                        {
                            extend: 'excel',
                            exportOptions: {
                                columns: ':visible'
                            }
                        },
                        {
                            extend: 'csv',
                            exportOptions: {
                                columns: ':visible'
                            }
                        },
                        {
                            extend: 'pdf',
                            exportOptions: {
                                columns: ':visible'
                            }
                        },
                        {
                            extend: 'print',
                            exportOptions: {
                                columns: ':visible'
                            }
                        }
                    ],
                },
            ],


            fixedHeader: {
                footer: false
            },
            "scrollY": "400px",
            "scrollCollapse": true,
            "paging": false
        });

    });
