<?php

// $sourcePath = '/path/to/source/css/file.css';
// $minifier = new Minify\CSS($sourcePath);
// // we can even add another file, they'll then be
// // joined in 1 output file
// $sourcePath2 = '/path/to/second/source/css/file.css';
// $minifier->add($sourcePath2);
// // or we can just add plain CSS
// $css = 'body { color: #000000; }';
// $minifier->add($css);
// // save minified file to disk
// $minifiedPath = '/path/to/minified/css/file.css';
// $minifier->minify($minifiedPath);
// // or just output the content
// echo $minifier->minify();
use MatthiasMullie\Minify;

// Alias Editor classes so they are easy to use
use
    DataTables\Editor,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Mjoin,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate;


class AdminController extends AppController
{
    public function __construct($f3)
    {
    }

    public function viewAdminPropertyPage($f3)
    {
        // Page title
        $f3->set('pid_propadmin','active');
        $f3->set('pagename','Property Administration');
        $f3->set('pagetitle', $f3->get('SYSTEM_NAME') . ' | ' . $f3->get('pagename'));
        $f3->set('headerflags', array($f3->get('jsc_datatables')));

        // Get page JS and minify.
        $f3->set('page_js',Template::instance()->render('page/content/adminproperty.js'));
        $min = new Minify\JS($f3->get('page_js'));
        $f3->set('page_js', $min->minify());

        // Render page with minified JS included
        echo Template::instance()->render('page/content/adminproperty.html');
    }

    public function viewAdminPropRateCodes($f3)
    {
        // Page title
        $f3->set('pid_propratecodes','active');
        $f3->set('pagename','Property Rate Code Administration');
        $f3->set('pagetitle', $f3->get('SYSTEM_NAME') . ' | ' . $f3->get('pagename'));
        $f3->set('headerflags', array($f3->get('jsc_datatables')));

        // Decode property id parameter.
        $f3->set('ratecodeprop', $f3->get('encrypt_agent')->decode($f3->get('PARAMS.propid')));
        // Get the name of the property from user props.
        $a = array_column($f3->get('userprops'), 'propname', 'propid');
        $f3->set('propname', $a[$f3->get('ratecodeprop')]);

        // $f3->set('erc_row', new DB\SQL\Mapper($f3->get('DB'),'ih_eligibleratecodes'));
        // // Find returns an array of mapper objects.
        // $f3->get('erc_row')->find(array('propid=?', $f3->get('ratecodeprop')));
        // // Create array out of mapper object.
        // $a = $f3->get('erc_row')->cast();
        // ~r($a, $f3->get('erc_row'), $f3->get('ratecodeprop'));
        // $f3->set('erc_rows', $a);

        // $sql = 'select ERCId, PropID, RateCode, RateDesc, StartDate, EndDate, EligibilityCode, CreateUser, CreateDate, UpdateUser, UpdateDate' .
        //         ' from ih_eligibleratecodes where PropID = :pid and (LegacyActionCode not like :str)';

        // try {
        //     $r = $f3->get('DB')->exec($sql, array( 'pid' => $f3->get('ratecodeprop'), 'str' => 'd%'));
        // } catch (Exception $e) {
        //     echo $e->getMessage();
        //     exit;
        // }

        // Get rates for property.
        $f3->set('proprates', $f3->get('DB')->exec(
                'select ERCId, PropID, RateCode, RateDesc, StartDate, EndDate, EligibilityCode, CreateUser, CreateDate, UpdateUser, UpdateDate' .
                " from ih_eligibleratecodes where PropID = " . $f3->get('ratecodeprop') . " and LegacyActionCode not like 'd%'"));


        // Shorten descriptions over 30 char.
        foreach ($f3->get('proprates') as $recnum => $record) 
        {
            if ( strlen($f3->get('proprates')['RateDesc']) > 30 )
            {
                // $f3['proprates'][$recnum]['RateDesc'] = substr($record['RateDesc'], 0, 40) . '...';
            }
        }
        // Get page JS and minify.
        $f3->set('page_js',Template::instance()->render('page/content/adminpropratecodes.js'));
        $min = new Minify\JS($f3->get('page_js'));
        $f3->set('page_js', $min->minify());
    
        echo Template::instance()->render('page/content/adminpropratecodes.html');

    }


    // public function viewAdminPropBulletins($f3)
    // {
    //  // Page title
    //  $f3->set('pagename','Property Rate Cpde Administration');
    //  $f3->set('pagetitle', $f3->get('SYSTEM_NAME') . ' | ' . $f3->get('pagename'));
    //  $f3->set('headerflags', array($f3->get('jsc_datatables')));
    //  echo Template::instance()->render('page/content/adminpropratecodes.html');

    // }


    // AJAX request.
    public function editAdminPropRateCodes($f3) 
    {

        // Setup return value.
        $ret_data = array();
        $err_data = array();                        // JS object sent back to DT on error.
        $f3->set('legacy_load', '');                 // Hive needed for mapper copyTo

        // Get action in small variable.
        $act = $f3->get('payload.action');

        //
        // Validation
        // 
        foreach ($f3->get('payload.data') as $ercid => $ercrow) 
        {

            // Validate fields and create error messages with indices.
            for ($i=0; $i < 99; $i++) 
            { 
                // If we have errors, break out.
                if ( !empty($err_data) )
                    break;

                switch ($i) 
                {
                    case 0:
                        if ( empty($ercrow['RateCode']) ) 
                        { 
                            $err_data['fieldErrors']['name' . $i]       = "RateCode";
                            $err_data['fieldErrors']['status' . $i]     = "Rate Code can not be blank!";
                            break;
                        }
                        if ( ! ctype_alnum($ercrow['RateCode']) )
                        { 
                            $err_data['fieldErrors']['name' . $i]       = "RateCode";
                            $err_data['fieldErrors']['status' . $i]     = "Rate Code must contain only letters and numbers";
                            break;
                        }
                        break;
                    case 1:
                        if ( empty($ercrow['RateDesc']) ) 
                        { 
                            $err_data['fieldErrors']['name' . $i]       = "RateDesc";
                            $err_data['fieldErrors']['status' . $i]     = "Rate Description can not be blank!";
                        }
                        break;
                    case 2:
                        $validstartdate = TRUE;
                        if ( MainController::validateDate($ercrow['StartDate']) !== TRUE ) 
                        { 
                            $err_data['fieldErrors']['name' . $i]       = "StartDate";
                            $err_data['fieldErrors']['status' . $i]     = "Start Date format must be YYYY-MM-DD";
                            $validstartdate = FALSE;
                        }
                        break;
                    case 3:
                        $validenddate = TRUE;
                        if ( MainController::validateDate($ercrow['EndDate']) !== TRUE ) 
                        { 
                            $err_data['fieldErrors']['name' . $i]       = "EndDate";
                            $err_data['fieldErrors']['status' . $i]     = "End Date format must be YYYY-MM-DD";
                            $validenddate = FALSE;
                        }
                        break;
                    case 4:
                        if ( $validstartdate and $validenddate and ($ercrow['StartDate'] >= $ercrow['EndDate']) ) 
                        { 
                            $err_data['fieldErrors']['name' . $i]       = "StartDate";
                            $err_data['fieldErrors']['status' . $i]     = "Start Date must be prior to End Date";
                            $i += 1;
                            $err_data['fieldErrors']['name' . $i]       = "EndDate";
                            $err_data['fieldErrors']['status' . $i]     = "End Date must be after to Start Date";
                        }
                        break;
                    case 5:
                        // Make sure there are not any rate codes with this rate code already exists on a create.
                        if ($act == "create" )
                        {
                            $erc = new DB\SQL\Mapper($f3->get('DB'), 'ih_eligibleratecodes');
                            $erc->load(array('RateCode = ? and PropID = ?', $ercrow['RateCode'], $ercrow['PropID']));
                            if ( ! $erc->dry() )
                            { 
                                $err_data['fieldErrors']['name' . $i]       = "RateCode";
                                $err_data['fieldErrors']['status' . $i]     = "Rate Code already exists.";
                            }
                        }
                        break;
                    default:
                        $i = 100;
                        break;
                }
            }

            // if error, return error JSON and return
            if ( !empty($err_data) )
            {
                // Wrap and adjust json as needed by DT.
                $err_data = json_encode($err_data);
                $err_data = preg_replace('/,"name[0-9]"/', '},{"name"', $err_data);
                $err_data = preg_replace('/"name[0-9]"/', '"name"', $err_data);
                $err_data = preg_replace('/status[0-9]/', 'status', $err_data);
                $err_data = str_replace('"fieldErrors":{', '"fieldErrors":[{', $err_data);
                $err_data = str_replace('}}', '}]}', $err_data);
                echo $err_data;
                return;
            }
        }

        // Prepare to update databases
        $erc = new DB\SQL\Mapper( $f3->get('DB'), 'ih_eligibleratecodes');
        $erca = new DB\SQL\Mapper( $f3->get('DB'), 'ih_eligibleratecodesaudit');

        //
        // Database Update
        // 
        $i = 0;
        foreach ($f3->get('payload.data') as $ercid => $ercrow) 
        {
            // ~r($f3->get('payload.data'), $f3->get('payload.data')[$ercid]);
            // If edit or delete, get original record and set return data id
            if ( $act == 'edit' or $act == 'remove' )
            {
                $erc->load(array('ERCId=?', $ercid));

                // If this is an edit, then audit this original record.
                if ( $act == 'edit' )
                {
                    $ERCAId = MainController::createAudit($erc, $erca, 'ERCAId');
                }
            }

            // update record buffer and set return data for DT.
            foreach ($ercrow as $fieldname => $fieldvalue)
            {
                // Do not copy the DT row id field.
                if ( $fieldname != 'DT_RowId' )
                {
                    // update field buffers.
                    // double up the apostrophe
                    $fieldvalue = str_replace("'", "''", $fieldvalue);
                    $erc->$fieldname = $fieldvalue;
                }

                // Add field to return data for DT.
                $ret_data["data$i"][$fieldname] = $fieldvalue;

            }

            // Update user fields.  It knows how.
            MainController::UpdateUserFields($erc, $f3->get('username'));

            // Perform database action based on form action.
            switch ( $act )
            {
                case 'create':
                    // Set legacy database update code.
                    $erc->LegacyActionCode = $f3->get('LAC_New');

                    // Set effect dates to same as start and end dates for now.
                    $erc->EffectStartDate = $erc->StartDate;
                    $erc->EffectStopDate = $erc->EndDate;

                    // Save and set new id number in return data.
                    $erc->save();

                    // Save data for legacy transport -  - LAC_Edit will indicate action.
                    $erc->copyto('legacy_load');

                    // Returns "1" or "0 - [message]"
                    $r = MainController::sendLegacyUpdate($f3->get('legacy_load'), 'eligibleratecodes', 'ERCId', $f3->get('LAC_New'));
                    if ( $r['body'] != 1 )
                    {
                        // Return error to DT.
                        $err_data['error'] = 'A system error has occurred (ERCNEW).  No records were added.';

                        // Log this to the log file.
                        $f3->get('logger')->addCritical('Unable to update legacy database (ERCNEW).');
                        $f3->get('logger')->addInfo('(ERCNEW): ' . 
                                json_encode(array_merge(array('errormsg' => $r), $f3->get('legacy_load'))));

                        // Erase the record we just added.
                        $erc->erase();

                        // We are done here.
                        break;
                    }


                    // Add fields not sent from form on a create to return to DT.
                    $ret_data['data'.$i]['DT_RowId'] = $erc->ERCId;
                    $ret_data['data'.$i]['ERCId'] = $erc->ERCId;
                    $ret_data['data'.$i]['CreateUser'] = $erc->CreateUser;
                    $ret_data['data'.$i]['CreateDate'] = $erc->CreateDate;
                    $ret_data['data'.$i]['UpdateUser'] = $erc->UpdateUser;
                    $ret_data['data'.$i]['UpdateDate'] = $erc->UpdateDate;
                    break;

                case 'edit':
                case 'remove':

                    // The original record was copied to audit above and key field value saved.

                    // Set legacy action code before updating
                    $erc->LegacyActionCode = ($act == 'edit') ? $f3->get('LAC_Edit') : $f3->get('LAC_Delete');
                    $msgcode = ($act == 'edit') ? 'ERCEDIT' : 'ERCREMOVE';

                    // Save data for legacy transport - LAC_Edit will indicate action.
                    $erc->copyto('legacy_load');

                    // Send legacy system data.
                    // Returns "1" or "0 - [message]"
                    $r = MainController::sendLegacyUpdate($f3->get('legacy_load'), 'eligibleratecodes', 'ERCId', $f3->get('LAC_Edit'));
                    if ( $r['body'] != 1 )
                    {
                        // Return error to DT.
                        $err_data['error'] = "A system error has occurred ($msgcode).  No updates were made.";

                        // Log this to the log file.
                        $f3->get('logger')->addCritical("Unable to update legacy database ($msgcode).");
                        $f3->get('logger')->addInfo("($msgcode): " . 
                                json_encode(array_merge(array('errormsg' => $r), $f3->get('legacy_load'))));

                        // Erase the audit record we saved earlier.
                        $erca->reset();
                        $erca->load(array('ERCAId = ?', $ERCAId));
                        if ( ! $erca->dry() )
                            $erca->erase();

                        // We are done here.
                        break;
                    }

                    // Sybase is updated.  Update MySQL.
                    $erc->save();


                    // Add id to return value in DT_Row form for DT.
                    $ret_data["data$i"]['DT_RowId'] = 'row_' . $ercid;

                    break;

                default:
                    # code...
                    break;
            }
            $i++;
        }

        // First see if there was a general error message.
        if ( !empty($err_data['error']) )
        {
            $ret_data = json_encode($err_data);
            echo $ret_data;
            return;
        }

        // If not a remove, then adjust json and echo.
        if ( $act != 'remove' )
        {
            // Wrap and adjust json as needed by DT.
            $ret_data = json_encode($ret_data);
            // ~r($ret_data);
            $ret_data = str_replace('"data0":{', '"data":[{', $ret_data);
            $ret_data = str_replace('}}', '}]}', $ret_data);
            // when processing multi-edits.
            $ret_data = preg_replace('/"data[1-9999]":/', '', $ret_data);

            echo $ret_data;
            return;
        }

        // If remove action.
        echo "{}";

    }


    public function editAdminPropRateCodes_hold($f3)    
    {

        // Last update on this method - DMW 05/11/16 9:14 AM
        // Went back to doing it manually instead of working around this object.

        // DataTables PHP library
        global $sql_details;
        include( $f3->get('VENDOR_CODE') . "editor/php/DataTables.php" );

        $editor = Editor::inst( $db, 'ih_eligibleratecodes', 'ercid' )
            ->fields(
                Field::inst( 'ercid' ),
                Field::inst( 'propid' )->setValue($data['propid']),
                Field::inst( 'ratecode' )->validator( 'Validate::notEmpty' ),
                Field::inst( 'ratedesc' )->validator( 'Validate::notEmpty' ),
                Field::inst( 'startdate' )
                    ->validator( 'Validate::dateFormat', 'Y-m-d' )
                    ->validator( 'Validate::notEmpty' )
                    ->validator( function ( $val, $data, $opts ) {
                        $retval = TRUE;
                        if ($data['startdate'] >= $data['enddate']) 
                        {
                            $retval = 'Start Date must be BEFORE End Date.';
                        }
                        return $retval;
                    }),
                Field::inst( 'enddate' )
                    ->validator( 'Validate::dateFormat', 'Y-m-d' )
                    ->validator( 'Validate::notEmpty' )
                    ->validator( function ( $val, $data, $opts ) {
                        $retval = TRUE;
                        if ($data['startdate'] >= $data['enddate']) 
                        {
                            $retval = 'End Date must be AFTER Start Date.';
                        } 
                        return $retval;
                    }),
                Field::inst( 'eligibilitycode' )
                    ->validator( 'Validate::minMaxNum', array("min" => 0, "max" => 1) ),
                Field::inst( 'createuser' )
                    ->setFormatter(function ( $val, $data, $opts ) {
                        $retval = $data['createuser'];
                        if ( Editor::action( $_POST ) === Editor::ACTION_CREATE ) 
                        {
                            $f3 = \Base::instance();
                            $retval = $f3->get('username');
                        }
                        return $retval;

                    }),
                Field::inst( 'createdate' )
                    ->setFormatter(function ( $val, $data, $opts ) {
                        $retval = $data['createdate'];
                        if ( Editor::action( $_POST ) === Editor::ACTION_CREATE ) 
                        {
                            $retval = date('Y-m-d');
                        }
                        return $retval;
                    }),
                Field::inst( 'updateuser' )
                    ->setFormatter(function ( $val, $data, $opts ) {
                        if ( Editor::action( $_POST ) === Editor::ACTION_CREATE or 
                                 Editor::action( $_POST ) === Editor::ACTION_EDIT ) 
                        {
                            $f3 = \Base::instance();
                            return $f3->get('username');
                        }
                    }),
                Field::inst( 'updatedate' )
                    ->setFormatter(function ( $val, $data, $opts ) {
                        if ( Editor::action( $_POST ) === Editor::ACTION_CREATE or 
                                 Editor::action( $_POST ) === Editor::ACTION_EDIT ) 
                        {
                            return date('Y-m-d');
                        }
                    })
            )
            ->process( $_POST )
            ->json();

            // Audit trail.
            $erc_audit = new DB\SQL\Mapper($f3->get('DB'),'ih_eligibleratecodesaudit');
    }



}