<?php

class MainController extends AppController
{
	public function viewHomePage()
	{
		echo "iHAMMS Online Application Web Edition";
		// echo Template::instance()->render('layout2/content/test.html');
	}

	public function legacylogout($f3)
	{
		// Force logout from page timer or otherwise.
		 //~r($f3->get('COOKIE'));
		$ccode = $f3->get('encrypt_agent')->decode($f3->get('COOKIE.chaincode'));
		$this->clear_legacy_cookies($f3);
		$f3->reroute( $f3->get('LEGACY_LOGIN_URL') . $ccode );
	}

	private function clear_legacy_cookies($f3)
	{
		$f3->clear('COOKIE.userchain');
        // Chain Code ( ie. hmh )
        $f3->clear('COOKIE.chaincode');
        // Session code string ( userid, sessionid, userpass, userlogin, currenttime, PIN (optional) )
        $f3->clear('COOKIE.userid');
        // User name - Login name
        $f3->clear('COOKIE.username');
        // User full name (first, last)
        $f3->clear('COOKIE.userpwd');
        // User PIN for easy login
        $f3->clear('COOKIE.userpin');
        // User full name (first, last)
        $f3->clear('COOKIE.userfullname');
	}

	public static function UpdateUserFields($dbmap, $username)
	{
		$f3 = \Base::instance();
		// See if this is an audit file.
		$p = in_array('ACreateDate', $dbmap->fields()) ? 'A' : '';

		// Create date.
		if ( empty($dbmap[ $p . 'CreateUser']) )
		{
			$dbmap[$p . 'CreateDate'] = $f3->get('SQL_DATE');
			$dbmap[$p . 'CreateUser'] = $username;
		}
		$dbmap[$p . 'UpdateDate'] = $f3->get('SQL_DATE');
		$dbmap[$p . 'UpdateUser'] = $username;

	}

	public static function validateDate($date, $format = 'Y-m-d')
	{
	    $d = DateTime::createFromFormat($format, $date);
	    return $d && $d->format($format) == $date;
	}

	// $payload		= assoc array of database fields => values.
	// $tablename   = table name on legacy system that is to receive this message.
	// $keyname     = table field name that is the unique identifier a row in $tablename.
	// $action      = code for action to take on legacy database - see LAC_ in globals.
	public static function sendLegacyUpdate($payload, $tablename, $keyname, $actioncode)
	{
		$f3 = \Base::instance();
		// Encrypt the payload.
		$payload = $f3->get('encrypt_agent')->encode(json_encode($payload));
		$tablename = $f3->get('encrypt_agent')->encode($tablename);
		$keyname = $f3->get('encrypt_agent')->encode($keyname);
		$actioncode = $f3->get('encrypt_agent')->encode($actioncode);

		$url = $f3->get('LDU_URL');

		$postVars = array(
		    'payload' => $payload,              // encrypted json-encoded data array.
		    'tablename' => $tablename,			// encrypted name of table to update.
		    'keyname' => $keyname,				// encrypted name of table to update.
		    'actioncode' => $actioncode			// encrypted action code to perform on legacy table.
		);

		$options = array(
		    'method'  => 'POST',
		    'content' => http_build_query($postVars),
		);

		$r = \Web::instance()->request($url, $options);
		// ~r($r);
		return($r);
		
	}

	// Creates an audit record in the database for F3 mapper record.
	// $from            	= F3 mapper to copy from.
	// $to 					= F3 mapper to copy to.
	// $keyname	            = name of key field in audit table.
	// Presumed the DB is setup correctly.
	// Returns the id of the new record created in the audit table.
	public static function createAudit($from, $to, $keyname)
	{
		$f3 = \Base::instance();

	    $to->copyfrom($from);

	    // Update user fields.  It knows how.
	    MainController::UpdateUserFields($to, $f3->get('username'));
	    $to->save();

	    // Get ERCAID in case we need to back this out.
	    $NewID = $to->$keyname;

	    // Reset for next update.
	    $to->reset();

	    return $NewID;
	}

}